unit mdfPage;
{=====================================================================}
interface
{=====================================================================}
{$I mdfpage.inc}
{=====================================================================}
operator = (pid1, pid2 : TmdfPageId) b : boolean;
{=====================================================================}
function  mdfPageOpen(f:longint;start,size:Int64):PmdfPageStream;
procedure mdfPageClose(var p:PmdfPageStream);
{---------------------------------------------------------------------}
function  mdfPageGetPageWithIdType(p:PmdfPageStream;id:dword;ptype:byte;pid:PmdfPageId):boolean;
function  mdfPageGetPageWithPid(p:PmdfPageStream;pid:PmdfPageId;page:PmdfPage;force:boolean):boolean;
function  mdfPageGetPageWithNumber(p:PmdfPageStream;number:dword;page:PmdfPage;rtp:boolean):boolean;
{---------------------------------------------------------------------}
function  mdfPageIdIsNull(pid:PmdfPageId):boolean;
{---------------------------------------------------------------------}
function mdfPageGetTypeStr(m_type:byte):string;
function mdfPageGetIndexIdStr(m_indexId:word):string;
function mdfPageGetSysObjStr(m_objId:dword):string;
function mdfPageGetObjTypeStr(xtype:word):string;
{=====================================================================}
implementation
uses plMem,plStr,plFile64{,SysUtils},mdfType;
{=====================================================================}
const
    cache_pages            = 8;
    cache_size             = CmdfPageSize * cache_pages;
{=====================================================================}
procedure RemoveTearProof(p:PByte);
var
 q:PByte;
 i:integer;
begin
 i := 2;
 q := p + $3FF;
 with PmdfPageHeader(p)^ do begin
  if(m_reservedB and 1 <> 0)and
    ((m_tornBits and 3 = 1)or(m_tornBits and 3 = 2))then begin
   repeat
    q^ := ((m_tornBits shr i)and 3)or(q^ and $0FC);
    inc(q,$200);
    inc(i,2);
   until i >= $20;
   //m_reservedB := m_reservedB and -2;
  end;
 end;
end;
function getPage(p:PmdfPageStream;pageNumber:dword;rtp:boolean):pointer;
var
 i:integer;
begin
 result:=nil;
 if p<>nil then with p^ do begin
  if(_first_cached_page<>dword(-1))and(_number_cached_pages<>0)and
    (pageNumber>=_first_cached_page)and
    (pageNumber<_first_cached_page+_number_cached_pages)then
   result:=pointer(dword(_pbuff)+dword(dword(pageNumber-_first_cached_page)*CmdfPageSize))
  else if _page_cnt>pageNumber then begin
   _first_cached_page:=dword(pageNumber and dword(not dword(cache_pages-1)));
   MemSet(_pbuff,0,cache_size);
   _number_cached_pages:=0;
   if FileSeek(_file,_start+(Int64(p^._first_cached_page)*Int64(CmdfPageSize)),fsFromBeginning)<>-1 then begin
    if dword(_page_cnt-_first_cached_page)>=cache_pages then
     _number_cached_pages:=cache_pages
    else _number_cached_pages:=dword(_page_cnt-_first_cached_page);
    if FileRead(_file,_pbuff^,_number_cached_pages*CmdfPageSize)<>-1 then begin
     result:=pointer(dword(_pbuff)+dword(dword(pageNumber-_first_cached_page)*CmdfPageSize));
     if rtp then for i:=0 to _number_cached_pages-1 do RemoveTearProof(_pbuff+(i*CmdfPageSize));
    end;
   end;
  end;
 end;
end;
{=====================================================================}
function mdfPageGetPageWithNumber(p:PmdfPageStream;number:dword;page:PmdfPage;rtp:boolean):boolean;
var q:pointer;
begin
 if p<>nil then begin
  q:=getPage(p,number,rtp);
  if q<>nil then MemCopy(q,page,CmdfPageSize);
 end;
 result:=(p<>nil)and(q<>nil);
end;
{=====================================================================}
function mdfPageGetPageWithIdType(p:PmdfPageStream;id:dword;ptype:byte;pid:PmdfPageId):boolean;
var L:dword;
    q:PmdfPage;
begin
 result:=false;
 if p<>nil then begin
  L:=0;
  repeat
   q:=getPage(p,L,true);
   inc(L);
  until(q=nil)or((q^._ph.m_objId=id)and(q^._ph.m_type=ptype));
  if q<>nil then begin
   pid^:=q^._ph.m_pageId;
   result:=true;
  end;
 end;
end;
{---------------------------------------------------------------------}
function mdfPageIdIsNull(pid:PmdfPageId):boolean;
begin
 with pid^ do result:=(_fid=0)and(_id=0);
end;
{---------------------------------------------------------------------}
function mdfPageGetPageWithPid(p:PmdfPageStream;pid:PmdfPageId;page:PmdfPage;force:boolean):boolean;
var L:dword;
    q:PmdfPage;
begin
 result:=false;
 if(p<>nil)and(not mdfPageIdIsNull(pid)) then begin
  L:=pid^._id;

  // -- for some backup
  repeat
   q:=getPage(p,L,true);
   if L>=cache_pages then dec(L,cache_pages) else break;
  until (q<>nil)and(pid^=q^._ph.m_pageId);
  // ------------------

  if(q=nil)or(pid^<>q^._ph.m_pageId)then begin
   L:=0;
   if not force then q:=nil else repeat
    q:=getPage(p,L,true);
    inc(L);
   until(q=nil)or(pid^=q^._ph.m_pageId);
  end;
  if q<>nil then begin
   MemCopy(q,page,CmdfPageSize);
   result:=true;
  end;
 end;
end;
{---------------------------------------------------------------------}
operator = (pid1, pid2 : TmdfPageId) b : boolean;
begin
 b:=MemCmp(@pid1,@pid2,SizeOf(TmdfPageId))=0;
end;
{---------------------------------------------------------------------}
function mdfPageGetTypeStr(m_type:byte):string;
begin
 case m_type of
  CmdfPageData        :result:='DATA';
  CmdfPageIndex       :result:='INDEX';
  CmdfPageTextMix     :result:='TEXT_MIX';
  CmdfPageTextTree    :result:='TEXT_TREE';
  CmdfPageWF          :result:='WF';
  CmdfPageSort        :result:='SORT';
  CmdfPageGAM         :result:='GAM';
  CmdfPageSGAM        :result:='SGAM';
  CmdfPageIAM         :result:='IAM';
  CmdfPagePFS         :result:='PFS';
  CmdfPageBoot        :result:='BOOT';
  CmdfPageSysconfig   :result:='SYSCONFIG';
  CmdfPageFileheader  :result:='FILEHEADER';
  CmdfPageDiffMapPage :result:='DIFF_MAP_PAGE';
  CmdfPageMlMapPage   :result:='ML_MAP_PAGE';
  CmdfPageDumpHeader  :result:='DUMP_HEADER';
  CmdfPageDumpTrailer :result:='DUMP_TRAILER';
 else result:='UNKNOWN';
 end; {case}
end;
{---------------------------------------------------------------------}
function mdfPageGetIndexIdStr(m_indexId:word):string;
begin
 case m_indexId of
  $00:result:='TABENTRY';
  $01:result:='CLUSTIND';
  $02..$0FA:result:='NOCLUST';
  $0FF:result:='TXTENTRY';
 else result:='UNKNOWN';
 end; {case}
end;
{---------------------------------------------------------------------}
function mdfPageGetSysObjStr(m_objId:dword):string;
begin
 case m_objId of
  id_sysobjects         :result:='sysobjects';
  id_sysindexes         :result:='sysindexes';
  id_syscolumns         :result:='syscolumns';
  id_systypes           :result:='systypes';
  id_syscomments        :result:='syscomments';
  id_sysfiles1          :result:='sysfiles1';
  id_syspermissions     :result:='syspermissions';
  id_sysusers           :result:='sysusers';
  id_sysproperties      :result:='sysproperties';
  id_sysdepends         :result:='sysdepends';
  id_sysreferences      :result:='sysreferences';
  id_syfulltextcatalogs :result:='syfulltextcatalogs';
  id_sysindexkeys       :result:='sysindexkeys';
  id_sysforeignkeys     :result:='sysforeignkeys';
  id_sysmembers         :result:='sysmembers';
  id_sysprotects        :result:='sysprotects';
  id_sysfulltextnotify  :result:='sysfulltextnotify';
  id_sysdatabases       :result:='sysdatabases';
  id_sysperfinfo        :result:='sysperfinfo';
  id_sysprocesses       :result:='sysprocesses';
  id_sysxlogins         :result:='sysxlogins';
  id_syslocks           :result:='syslocks';
  id_sysdevices         :result:='sysdevices';
  id_sysmessages        :result:='sysmessages';
  id_sysconfigures      :result:='sysconfigures';
  id_syscurconfigs      :result:='syscurconfigs';
  id_sysservers         :result:='sysservers';
  id_syslockinfo        :result:='syslockinfo';
  id_syslanguages       :result:='syslanguages';
  id_syscharsets        :result:='syscharsets';
  id_syscursorrefs      :result:='syscursorrefs';
  id_syscursors         :result:='syscursors';
  id_syscursorcolumns   :result:='syscursorcolumns';
  id_syscursortables    :result:='syscursortables';
  id_syscacheobjects    :result:='syscacheobjects';
  id_sysaltfiles        :result:='sysaltfiles';
  id_sysfiles           :result:='sysfiles';
  id_sysfilegroups      :result:='sysfilegroups';
  id_sysallocations     :result:='sysallocations';
  id_allocation         :result:='ALLOCATION';
  else result:='';
 end; {case}
end;
{---------------------------------------------------------------------}
function mdfPageOpen(f:longint;start,size:Int64):PmdfPageStream;
begin
 result:=MemAlloc(SizeOf(TmdfPageStream));
 if result<>nil then with result^ do begin
  _file:=f;
  _start:=start;
  _size:=size;
  _page_cnt:=dword(size div CmdfPageSize);
  _first_cached_page:=dword(-1);
  _number_cached_pages:=0;
  _pbuff:=MemAlloc(cache_size);
  _version:=0;
  if(_pbuff=nil)or(getPage(result,0,true)=nil)then MemFree(result);
 end;
end;
{---------------------------------------------------------------------}
procedure mdfPageClose(var p:PmdfPageStream);
begin
 if p<>nil then begin
  MemFree(p^._pbuff);
  MemFree(p);
 end;
end;
{---------------------------------------------------------------------}
function mdfPageGetObjTypeStr(xtype:word):string;
begin
 case xtype of
  obj_AP: result:='application';
  obj_C : result:='check cns';
  obj_D : result:='default (maybe cns)';
  obj_F : result:='foreign key cns';
  obj_FN: result:='scalar function';
  obj_IF: result:='inline function';
  obj_L : result:='log';
  obj_P : result:='stored procedure';
  obj_PK: result:='primary key cns';
  obj_R : result:='rule';
  obj_RF: result:='replication filter proc';
  obj_S : result:='system table';
  obj_TF: result:='table function';
  obj_TR: result:='trigger';
  obj_U : result:='user table';
  obj_UQ: result:='unique key cns';
  obj_V : result:='view';
  obj_X : result:='extended stored proc'
  else result:='unknown '''+asStr(xtype,2)+'''';
 end; {case}
end;
{=====================================================================}
end.
