program mdfc;

uses plFile64,mdfPage,plMem,plStr;

const
 log1 = 'mdfc.log';
 header = 'MDFChecker 1.0 for MSSQL 7/8/9 data-files by General Paul Lee (c) 2006.';
 oper_s: packed array [1..5] of string = ('scan','scan with dump','patch','patch all','dump');

var
 f,L,dump:longint;
 pageStream:PmdfPageStream;
 p:PmdfPage;
 log:text;
 cmd:char;
 oper,param_first,param_last:byte;
 i,j:integer;
 s:string;

procedure die(msg:string);
begin
 {if vrb then} writeln(msg);
 halt(1);
end;

function ParseCmdLine:boolean;
var
 s:string;
begin
 result:=true;
 {----------------------------}
 oper:=0;
 param_first:=0;
 param_last:=ParamCount;
 cmd:='h'; //fname:=''; objname:='';
 {----------------------------}
 if ParamCount>1 then begin
  s:=ParamStr(1);
  byte(cmd):=byte(s[1])or$20;
 end;
 case cmd of
  's':begin
       oper:=1;
       param_first:=2;
       s:=ParamStr(2);
       if(byte(s[0])=2)and(s[1]in['-','/'])then begin
        if (byte(s[2])or$20=byte('d'))and(ParamCount=3)then begin
         oper:=2;
         param_first:=3;
        end else oper:=0;
       end;
      end;
  'p':if(ParamCount>2)then begin
       oper:=3;
       param_first:=2;
       s:=ParamStr(2);
       if(byte(s[0])=2)and(s[1]in['-','/'])then begin
        if (byte(s[2])or$20=byte('a'))and(ParamCount=3)then begin
         oper:=4;
         param_first:=3;
        end else oper:=0;
       end;
      end;
  'd':begin
       if(ParamCount>2)then begin
        oper:=5;
        param_first:=2;
       end;
      end;
  'o':begin
      end;
 end; {case}

 if(oper=0)then begin
  writeln;
  writeln('Usage: mdfc <command> [<switches>] <filename> [<other parameters>]');
  writeln;
  writeln(#9'Commands:');
  writeln;
  writeln(#9's - scan');
  writeln(#9'    -d dump');
  writeln(#9'p - patch');
  writeln(#9'    -a all files in directory');
  writeln(#9'd - dump');
{  writeln(#9'o - object dump');
  writeln(#9'    -p one page in one file');
  writeln(#9'    -d data-page');
  writeln(#9'    -i index-page');
  writeln(#9'    -a IAM-page');
  writeln(#9'    -t text-page');
  writeln(#9'    -o other pages type (all pages exclude -d -i -a -t)');}
  writeln(#9'h - help screen');
  writeln;
  result:=false;
 end else if not(oper in [1,2,3,5])then begin
  writeln('Operation not supported now. Sorry.');
  result:=false;
 end
end;

function CheckTearProof(L:longint;p:PmdfPage):boolean;
var
 q:PByte;
 i:integer;
 tb:byte;
 pos:qword;
begin
 result:=true;
 i := 2;
 q := PByte(p) + $3FF;
 pos:=L*CmdfPageSize;
 with p^._ph do begin
  if(m_headerVersion=CmdfPageHeader70)then begin
   if((m_reservedB and 1)<>0)then begin
    tb:=m_tornBits;
    if(((tb and 3)=1)or((tb and 3)=2))then begin
     repeat
      if(m_objId<>$63)
       //(not(m_type in [CmdfPageFileheader,CmdfPagePFS,CmdfPageBoot,CmdfPageGAM,CmdfPageSGAM,CmdfPageDiffMapPage,CmdfPageMlMapPage]))
       and((tb and 3)<>(q^ and 3))then begin

       if result then writeln(log,HexStr(@pos,8,'',0,1)+': TearProof flag present: page '+HexStr(L,4)+'h '
        +#9'm_type = '+mdfPageGetTypeStr(m_type)+#9'm_indexId = '+mdfPageGetIndexIdStr(m_indexId)
        +#9+'m_objId = '+HexStr(m_objId,4)+'h '+mdfPageGetSysObjStr(m_objId));

       pos:=(L*CmdfPageSize)+((i-2)*$100)+$3FF;
       writeln(log,HexStr(@pos,8,'',0,1)+': control bits is not correct (tb = '
        +HexStr(tb and 3,1)+'; cb = '+HexStr(q^ and 3,1)+')');
       result:=false;
      end;
      inc(q,$200);
      inc(i,2);
     until i >= $20;
     //m_reservedB := m_reservedB and -2;
    end else begin
     writeln(log,HexStr(@pos,8,'',0,1)+': TearProof flag present: page '+HexStr(L,4)+'h '
      +#9'm_type = '+mdfPageGetTypeStr(m_type)+#9'm_indexId = '+mdfPageGetIndexIdStr(m_indexId)
      +#9+'m_objId = '+HexStr(m_objId,4)+'h '+mdfPageGetSysObjStr(m_objId));
     write(log,HexStr(@pos,8,'',0,1));
     write(log,': TearProof is not correct (m_tornBits = ');
     writeln(log,HexStr(m_tornBits,1)+')');
     result:=false;
    end;
   end;
  end else if(m_headerVersion<>0)then begin
   writeln(log,HexStr(@pos,8,'',0,1)+': TearProof flag present: page '+HexStr(L,4)+'h '
    +#9'm_type = '+mdfPageGetTypeStr(m_type)+#9'm_indexId = '+mdfPageGetIndexIdStr(m_indexId)
    +#9+'m_objId = '+HexStr(m_objId,4)+'h '+mdfPageGetSysObjStr(m_objId));
   writeln(log,HexStr(@pos,8,'',0,1)+': unknown header ('+HexStr(m_headerVersion,1)+')');
   result:=false;
  end;
 end;
end;

begin
 writeln(header);
 if not ParseCmdLine then die('');
 if(oper in[3,4])then f:=FileOpen(ParamStr(param_first),fmOpenReadWrite)
 else f:=FileOpen(ParamStr(param_first),fmOpenRead);
 if f=-1 then die('file open error: '+ParamStr(param_first));
 pageStream:=mdfPageOpen(f,0,FileSize(f));
 if pageStream=nil then die('Memory allocation error');
 p:=MemAlloc(CmdfPageSize);
 if p=nil then die('Memory allocation error');
 L:=0;
 assign(log,log1);
 rewrite(log);
 writeln(log,header);
 writeln(log);
 writeln(log,'File = '+ParamStr(param_first));
 write(log,'Operation = ',oper_s[oper]);
 writeln(log);
 if(mdfPageGetPageWithNumber(pageStream,L,p,false))then begin
  if not((p^._ph.m_headerVersion=CmdfPageHeader70)
   and(p^._ph.m_type=CmdfPageFileheader))then begin
    write(log,'Unknown 1-st page header (');
    write(log,HexStr(p^._ph.m_headerVersion,1)+'h;');
    writeln(log,HexStr(p^._ph.m_type,1)+'h)')
  end else begin
   case oper of
    1,2:repeat
     write(#13,((L+1)*100) / pageStream^._page_cnt :3:2,'% ');
     if not CheckTearProof(L,p) then if oper=2 then begin
      dump:=FileCreate(HexStr(L,4)+'.dmp');
      if dump=-1 then writeln('can''t create dump') else begin
       FileWrite(dump,p^,CmdfPageSize);
       FileClose(dump);
      end;
     end;
     inc(L);
    until not mdfPageGetPageWithNumber(pageStream,L,p,false);
    3,5:begin
       for i:=param_first+1 to param_last do begin
        s:=ParamStr(i);
        writeln(s);
        write(log,s+#9);
        if(Pos('.',s)>0)then s:=Copy(s,1,Pos('.',s)-1);
        Val('$'+s,L,j);
        if j<>0 then begin
         writeln(log,'str->int error');
        end else if dword(L)>=pageStream^._page_cnt then begin
         writeln(log,'incorrect page number ',HexStr(L,4),
          '. Max page number = ',HexStr(pageStream^._page_cnt,4));
        end else begin
         if oper=3 then dump:=FileOpen(ParamStr(i),fmOpenRead)
         else dump:=FileCreate(HexStr(L,4)+'.dmp');
         if dump=-1 then writeln(log,'file open error')else begin
          FileSeek(f,Int64(L)*Int64(CmdfPageSize),fsFromBeginning);
          if((oper=3)and(FileRead(dump,p^,CmdfPageSize)<>-1)and(FileWrite(f,p^,CmdfPageSize)<>-1))
           or((oper=5)and(FileRead(f,p^,CmdfPageSize)<>-1)and(FileWrite(dump,p^,CmdfPageSize)<>-1))
          then writeln(log,'ok')
          else writeln(log,'error');
          FileClose(dump);
         end;
        end;
       end;
      end;
   end; {case}
  end;
 end;
 writeln(log);
 writeln(log,'End');
 Close(log);
 MemFree(p);
 mdfPageClose(pageStream);
 FileClose(f);
 die('End');
end.
